/* converts movisens binary data to timestamped text data */

#include <iostream>
#include <fstream>
#include <string>
#include <cstring>
#include <cstdlib>

#include <stdint.h>
#include <endian.h>

using namespace std;

void convert_acc(string base, string dirname) {
    string accfile = base + dirname + "/acc.bin";
    ifstream acc_in(accfile.c_str());
    if (acc_in.fail()) {
      cerr << "Could not open " << accfile << endl;
      return;
    }

    string rawfile = dirname + "acc";
    ofstream acc_raw_out(rawfile.c_str());
    if (acc_raw_out.fail()) {
      cerr << "Could not open " << rawfile << endl;
      return;
    }
  
    char* buf = (char*) malloc(6);
    int n = 0;
    while (acc_in.read(buf, 6), !acc_in.fail()) {
      acc_raw_out << 1000 * n / 64;
      for (int i = 0; i < 3; i++) {
        uint8_t x1 = buf[2*i];
        uint8_t x2 = buf[2*i+1];
        uint16_t x = 0;
        x = x1 | (x2 << 8);
        x = le16toh(x);
        int16_t v = x;
        acc_raw_out << ' ' << v;
      }
      acc_raw_out << endl;
      n++;
    }
}

void convert_temp(string base, string dirname) {
    string tempfile = base + dirname + "/temp.bin";
    ifstream temp_in(tempfile.c_str());
    if (temp_in.fail()) {
      cerr << "Could not open " << tempfile << endl;
      return;
    }

    string rawfile = dirname + "temp";
    ofstream temp_raw_out(rawfile.c_str());
    if (temp_raw_out.fail()) {
      cerr << "Could not open " << rawfile << endl;
      return;
    }
  
    char* buf = (char*) malloc(2);
    int n = 0;
    while (temp_in.read(buf, 2), !temp_in.fail()) {
      temp_raw_out << 1000 * n;

      uint8_t x1 = buf[0];
      uint8_t x2 = buf[1];
      uint16_t x = 0;
      x = x1 | (x2 << 8);
      x = le16toh(x);
      int16_t v = x;
      temp_raw_out << ' ' << v << endl;

      n++;
    }
}

int main(int argc, char** argv) {
  for (int i=1; i < argc; i++) {
    string dirname = argv[i];
    if (dirname[dirname.size()-1] == '/')
      dirname.erase(dirname.size()-1);

    string base;
    size_t index = dirname.find_last_of('/');
    if (index != string::npos) {
      base = dirname.substr(0, index + 1);
      dirname.erase(0, index + 1);
    }
    
    cout << dirname << endl;

    convert_acc(base, dirname);
    convert_temp(base, dirname);
  }
}
