import java.io.BufferedWriter;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.PrintStream;
import java.lang.reflect.Array;
import java.nio.charset.Charset;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.HashSet;
import java.util.Map.Entry;
import java.util.Set;

//import ElanFile.ElanAnnotation;



public class Starter {

	
	private static final Set<String> ACTIONS = new HashSet<String>(Arrays.asList(
		     new String[] {"climbing", 
		    		 "walking", 
		    		 "print", 
		    		 "conversation", 
		    		 "meeting", 
		    		 "working", 
		    		 "closeDoor", 
		    		 "openDoorForward",
		    		 "openDoorBackward",
		    		 "posterWatching",
		    		 "makeCoffee",
		    		 "getWater",
		    		 "checkCoffee"
		     }
		));

	private static final Set<String> ACTIONS0P = new HashSet<String>(Arrays.asList(
		     new String[] {"climbing",
		    		 "makeCoffee",
		    		 "print", 
		    		 "closeDoor", 
		    		 "openDoorForward",
		    		 "openDoorBackward",
		    		 "getWater",
		    		 "checkCoffee"
		     }
		));

	
	private static final Set<String> ACTIONS1P = new HashSet<String>(Arrays.asList(
		     new String[] {"climbing", 
		    		 "print", 
		    		 "conversation", 
		    		 "meeting", 
		    		 "working", 
		    		 "closeDoor", 
		    		 "openDoorForward",
		    		 "openDoorBackward",
		    		 "posterWatching",
		    		 "getWater",
		    		 "checkCoffee"
		     }
		));
	
	private static final Set<String> LOCATIONS = new HashSet<String>(Arrays.asList(
		     new String[] {"corr1", 
		    		 "corr2", 
		    		 "corr3", 
		    		 "corr4", 
		    		 "corr5",
		    		 "room214a", 
		    		 "room207", 
		    		 "stairs",
		    		 "room208",
		    		 "room218",
		    		 "room205", 
		    		 "room211",
		    		 "room210",
		    		 "WC"
		    		 }
		));
	
	private static final Set<String> LOC_ACTION = new HashSet<String>(Arrays.asList(
		     new String[] {"walking", 
		    		 "closeDoor", 
		    		 "openDoorForward",
		    		 "climbing"
		    		}
		));
	
	private static final Set<String> REACHABLE_CORR1 = new HashSet<String>(Arrays.asList(
			new String[]{
				"corr1",
				"corr2",
				"room207",
				"room210",
				"room211"
				}));
	
	private static final Set<String> REACHABLE_CORR2 = new HashSet<String>(Arrays.asList(
			new String[]{
				"corr2",
				"corr1",
				"corr3",
				"room205"
			}));
	
	private static final Set<String> REACHABLE_CORR3 = new HashSet<String>(Arrays.asList(
			new String[]{
				"corr3",
				"corr2",
				"corr4",
				"stairs",
				"WC"
			}));

	private static final Set<String> REACHABLE_CORR4 = new HashSet<String>(Arrays.asList(
			new String[]{
				"corr4",
				"corr3",
				"corr5",
				"room214a"
			}));
	
	private static final Set<String> REACHABLE_CORR5 = new HashSet<String>(Arrays.asList(
			new String[]{
				"corr5",
				"corr4",
				"room218"
			}));
	
	private static final Set<String> REACHABLE_ROOM207 = new HashSet<String>(Arrays.asList(
			new String[]{
				"room207",
				"corr1",
				"room208"
			}));
	
	private static final Set<String> REACHABLE_ROOM208= new HashSet<String>(Arrays.asList(
			new String[]{
				"room208",
				"room207"
			}));
	
	private static final Set<String> REACHABLE_ROOM210= new HashSet<String>(Arrays.asList(
			new String[]{
				"room210",
				"corr1"
			}));
	
	private static final Set<String> REACHABLE_ROOM211 = new HashSet<String>(Arrays.asList(
			new String[]{
				"room211",
				"corr1"
			}));
	
	private static final Set<String> REACHABLE_ROOM205 = new HashSet<String>(Arrays.asList(
			new String[]{
				"room205",
				"corr2"
			}));
	
	private static final Set<String> REACHABLE_ROOM214A = new HashSet<String>(Arrays.asList(
			new String[]{
				"room214a",
				"corr4"			
			}));
	
	private static final Set<String> REACHABLE_STAIRS= new HashSet<String>(Arrays.asList(
			new String[]{
				"stairs",
				"corr3"
			}));
	
	private static final Set<String> REACHABLE_ROOM218= new HashSet<String>(Arrays.asList(
			new String[]{
				"room218",
				"corr5"
			}));

	private static final Set<String> REACHABLE_WC= new HashSet<String>(Arrays.asList(
			new String[]{
				"WC",
				"corr3"
			}));
	
	private static final HashMap<String, Set<String>> ISREACHABLE = new HashMap<String, Set<String>>(){
		{
			put("corr1",REACHABLE_CORR1);
			put("corr2",REACHABLE_CORR2);
			put("corr3",REACHABLE_CORR3);
			put("corr4",REACHABLE_CORR4);
			put("corr5",REACHABLE_CORR5);
			put("room205",REACHABLE_ROOM205);
			put("room207",REACHABLE_ROOM207);
			put("room208",REACHABLE_ROOM208);
			put("room210",REACHABLE_ROOM210);
			put("room211",REACHABLE_ROOM211);
			put("room214a",REACHABLE_ROOM214A);
			put("room218",REACHABLE_ROOM218);
			put("WC",REACHABLE_WC);
			put("stairs",REACHABLE_STAIRS);
		};
	};
	
				
	/**
	 * @param args
	 * @throws Exception 
	 */
	public static void main(String[] args) throws Exception {
		
		// TODO Auto-generated method stub
		String inFilename = null;
		String outFilename = null;
		FileWriter planWriter = null;
		long maxAgentTime = 0;		
		FileWriter durWriter = null;
		int maxAgentI = 0;
			
		HashMap<String,ArrayList<Integer>> durations = new HashMap<String, ArrayList<Integer>>();
		HashMap<String, HashMap<Integer,String>> annotation = new HashMap<String, HashMap<Integer,String>>();
		
		for (int i = 0; i < args.length; i++) {
			if (args[i].equals("-f")){
				inFilename = args[i+1];
				i++;
				continue;
			}
			if (args[i].equals("-o")){
				outFilename = args[i+1];
				i++;
				continue;
			}
      // if (args[i].equals("-p")){
      //  planWriter = new FileWriter(args[i+1]);
      //  i++;
      //  continue;
      // }
      // if (args[i].equals("-d")){
      //  durWriter = new FileWriter(args[i+1]);
      //  i++;
      //  continue;
      // }
		}			
		if (null == inFilename){
			throw new Exception("missing filename"); 
		}
		
		int errors = 0;
		FileInputStream reader = new FileInputStream(inFilename);
	    ElanFile file = new ElanFile(reader, Charset.defaultCharset());
	    List<ElanFile.ElanTier> tiers = file.getTiers();
	    
	    int agentcount = tiers.size();
	    
	    for (int i=1;i<=agentcount;i++){
	    	String tiername = "Agent " + i + " - Aktion";
	    	String Agent = "agent" + i;
	    	long agentTime = 0;
	    	ElanFile.ElanTier actionElanTier = file.getTierByID(tiername);
	    	annotation.put(Agent, new HashMap<Integer, String>());
	    	
	    	if (null == actionElanTier){
	    		break;
	    	}
	    	maxAgentI = Math.max(maxAgentI,i);
	    	
	   
	    	ElanFile.ElanTier locationElanTier = new ElanFile.ElanTier("Agent " + i + " - Ort");
	    	List<ElanFile.ElanAnnotation> anns = actionElanTier.getAnnotations();
	    	if (0 != anns.get(0).getStartTime()){
	    		anns.get(0).setStartTime(0);
	    	}
	    	String lastLocation = "";
	    	boolean first=true;
	    	
	    	for (ElanFile.ElanAnnotation ann : anns) {
	    		String[] parts = ann.getValue().split("-");
	    		long duration = ann.getEndTime() - ann.getStartTime();
	    		//save duration
	    		
	    		
	    		if (duration < 1000){
	    			System.err.println("Error:" + agentTime/1000 + " The annotation " + ann.getValue() + " in tier " + tiername + " is to short (" + duration + ")");
	    			errors++;
	    		}
	    		
	    		if (2 > parts.length){
	    			System.err.println("Error:" + agentTime/1000 + " The annotation " + ann.getValue() + " in tier " + tiername + " has only " + parts.length + " parts");
	    			errors++;
	    		}
	    		String action  = parts[0];
	    		if (!ACTIONS.contains(action)){
	    			System.err.println("Error:" + agentTime/1000 + " Action " + action + " is not allowed");
	    			errors++;
	    		}
	    		String location = parts[parts.length - 1];
	    		if (!LOCATIONS.contains(location)){
	    			System.err.println("Error:" + agentTime/1000 + " Location " + location + " is not allowed");
	    			errors++;
	    		}
	    		
	    		if (!location.equals(lastLocation)){ 
	    			if (lastLocation.isEmpty()){
	    				
	    			}else if (!LOC_ACTION.contains(action)){
	    				System.err.println("Error:" + agentTime/1000 +" Action " + action + " cannot change location from " + lastLocation + " to " + location);
		    			errors++;	
	    				
	    			}else if (!ISREACHABLE.get(lastLocation).contains(location)){
	    				System.err.println("Error:" + agentTime/1000 + "Location" + location + " is not reachable from " + lastLocation);
		    			errors++;	
	    				
	    			}
	    			
	    			lastLocation = location;
	    		}
	    		
	    		
	    		String durkey = action + " " + location + " " + Agent;
	    		if (!durations.containsKey(durkey)){
	    			durations.put(durkey, new ArrayList<Integer>());
	    		}
	    		
	    		
	    		
	    		long tmp = agentTime;
	    		int dur=0;
	    		while (agentTime >= ann.getStartTime() && agentTime < ann.getEndTime()){
	    			
	    			String s = getPlanEntry(dur==0,Agent, action, location, lastLocation);
	    			annotation.get(Agent).put((int) (agentTime/1000) , s);
	    			
	    			System.out.println(agentTime/1000 + " " + action + " " + Agent + " " + location);
	    			
	    			agentTime += 1000;
	    			if(!first){ // ignore the very first step to be sure that the first action can be aber INITIALIZE
	    			  dur++;
	    			}else{
	    			  first = false;
	    			}
	    		}
	    		durations.get(durkey).add(dur);
	    		if (tmp == agentTime){ // not changed, annotation will be skipped
	    			
	    			System.err.println("Skipping annotation " + ann.getValue() + " in tier " + tiername + " with duration " + duration);
	    		}
	    		
	    		
	    		ElanFile.ElanAnnotation locann = new ElanFile.ElanAnnotation(location, ann.getStartTime(), ann.getEndTime());
	    		locationElanTier.addAnnotation(locann);
	    		maxAgentTime = Math.max(maxAgentTime, agentTime/1000);
			}
	    	file.addTier(locationElanTier);
	    	
	    }
	    
	    if (null != planWriter){
	    	BufferedWriter b = new BufferedWriter(planWriter);
	    
	    	for (int i=0; i<maxAgentTime;i++){
	    		b.write(i + " ");
	    		for (int agentI = 0;agentI<maxAgentI;agentI++){
	    			HashMap<Integer, String> hm = annotation.get("agent"+(agentI+1));
	    			if (null == hm){continue;}
	    			String sentry = hm.get(i);
	    			b.write(sentry);
				}
	    		b.write("\n");
	    	}
	    	b.close();
	    }
	    
	    
	    
	    
	    if (null != outFilename)
	    file.write(new FileOutputStream(outFilename));
	    if (0!= errors){
	    	System.err.println("Found " + errors + " errors while processing annotation file.");
	    }
	    
	    if (null != durWriter){
	    	BufferedWriter writer = new BufferedWriter( durWriter );
			
	    	for (String key: durations.keySet()) {
	    		
				for (Integer dur : durations.get(key)) {
					writer.write(key + " " + dur + "\n");		
				}
			}	
	    	writer.close();			
	    }
	}


	private static String getPlanEntry(Boolean isnew, String Agent, String Action, String Location1, String Location2) {
		// TODO Auto-generated method stub
		StringBuilder sb = new StringBuilder();
		sb.append(isnew ? ",*,":",,");
		sb.append("(");
		if (Action.equals("climbing")){
			Action = "climbingStairs";
			Location1 = null;
		}
		if (Action.equals("posterWatching")){
			Action = "watchingPoster";
			Location1 = null;
		}	
		sb.append(Action);
		sb.append("-");
		sb.append(Agent);
		if (null != Location1 && ! Location1.isEmpty() && ! ACTIONS0P.contains(Action) ){
			sb.append("-");
			sb.append(Location1);
			if (null != Location2 && ! Location2.isEmpty() && ! ACTIONS1P.contains(Action) ){
				sb.append("-");
				sb.append(Location2);
			}
		}
		
		
		sb.append(")");
	

		return sb.toString();
	}
}


