//============================================================================
// Name        : durationAnoMA.cpp
// Author      : Martin
// Version     :
// Copyright   : 
// Description : Create the anonymous multi agent duration file for a given file of roomstates.
//				(roomstate file maust contain a line with the room name before the roomstate itself. input if std::in)
//============================================================================

#include <iostream>
#include <vector>
#include <algorithm>
#include <sstream>
using namespace std;

#define NAgent 7 //maximum number of persons

int main(int argc, char **argv) {

	string room;
	string oldRoom;
	//read input
	int x;
	vector<int> input;

	//	vector<int> input;
	//	int tmp[] = {0,1,2,2,1,1,2,2,0};
	//	for(unsigned int i = 0; i < sizeof(tmp) / sizeof(int); i++){
	//		input.push_back(tmp[i]);
	//	}

	//http://stackoverflow.com/questions/6850246/ifstreams-operator-to-detect-end-of-line
	string line;

	for(int i = 0; i < 14; i++){

		input.clear(); //reset vector

		//read room name
		oldRoom = room;
		cin >> room;
		if(oldRoom.compare(room) == 0){
			break;
		}
		cin.ignore(10000, '\n');

		//read data
		getline(cin, line);
		stringstream linestream(line);
		while(linestream >> x){
			input.push_back(x);
		}


		vector<int> durations;
		int risingEdge[NAgent];
		int risingEdgeNum = 0;
		int fallingEdgeNum = 0;
		int lastElem = 0;
		for(unsigned int i = 0; i < input.size(); i++){
			if(lastElem < input[i]){ //rising edge detected
				for(int j = lastElem; j < input[i]; j++){ //can be more then one person entering a room
					risingEdge[risingEdgeNum++] = i; //insert the rising edge
				}
			}
			else if(lastElem > input[i]){ //falling edge found
				for(int k = input[i]; k < lastElem; k++){ //can be more then one person entering a room
					//for each detected rising edge insert the duration to this falling edge
					for(int j = 0; j < risingEdgeNum; j++){
						durations.push_back(i - risingEdge[j]);
					}
					fallingEdgeNum++;
				}

			}
			lastElem = input[i];
			if((fallingEdgeNum != 0) && (fallingEdgeNum == risingEdgeNum)){ //reset
				risingEdgeNum = 0;
				fallingEdgeNum = 0;
			}
		}

		for(unsigned int i = 0; i < durations.size(); i++){
			cout << "NOACTION " << room << " NOAGENT " << durations[i] << endl;
		}

	}//end of for i < 14 (read cin)

//	int sortDur[durations.size()];
//	for(unsigned int i = 0; i < durations.size(); i++){
//		sortDur[i] = durations[i];
//	}
//
//
//	sort(sortDur, sortDur + durations.size());
//
//
//	lastElem = sortDur[0];
//	int countSame = 1;
//	int elements = 0;
//	cout << room << "durs[][2] = {";
//	for(unsigned int i = 1; i < durations.size(); i++){
//		if(lastElem == sortDur[i]){
//			countSame++;
//		}
//		else{
//			cout << "{" << lastElem << "," << countSame << "},";
//			countSame = 1;
//			elements++;
//		}
//		lastElem = sortDur[i];
//	}
//	cout << "{" << lastElem << "," << countSame << "}}" << endl;
//	elements++;
//	cout << room << "Elem = " << elements << ";" << endl;
//	cout << room << "Sum = " << durations.size() << ";" << endl;



	return 0;
}
