usage() {
cat <<EOF
Usage: $0 <dataset><iteration><workingfolder>
EOF
}


if [ "$#" -ne 3 ]; then
  usage >&2
  exit 1
fi


dataset=$1
iteration=$2
folder=$3

#call the R script to get the roomstate
cat plot.R > ${folder}/tmpRoomState.R
cat >>${folder}/tmpRoomState.R <<EOF
anno <- readMAanno($dataset,$iteration)
EOF

#cat("0\n") -> printing a "0" at the end enforces a falling edge even if there are persons in a room at the end of the experiment
# -> so we get the duration for this time (if there is no person it has no effect) 
for (( i=1 ; i <= 14 ; i++ )); do
cat >>${folder}/tmpRoomState.R <<EOF
cat(roomnames[$i],"\n")
printroomstate(anno,$i)
cat(" 0\n") 
EOF
done

R --slave -f ${folder}/tmpRoomState.R > ${folder}/tmpRoomState_${dataset}_${iteration}.txt

#run c-tool to get the duration file from the roomstates
g++ create-ano-ma-durationfile.cpp -o ${folder}/create-ano-ma-durationfile
chmod u+x ${folder}/create-ano-ma-durationfile

${folder}/create-ano-ma-durationfile < ${folder}/tmpRoomState_${dataset}_${iteration}.txt

#clean up
rm ${folder}/tmpRoomState.R
rm ${folder}/create-ano-ma-durationfile
rm ${folder}/tmpRoomState_${dataset}_${iteration}.txt
