usage() {
cat <<EOF
Usage: $0 [options] <dataset><iteration><inputfolder><outputfolder>
EOF
}

if [ "$#" -ne 4 ]; then
  usage >&2
  exit 1
fi


dataset=$1
iteration=$2
input=$3
output=$4

#run checker
java -jar elanChecker.jar  -f ${input}/${dataset}_${iteration}.eaf -o ${output}/${dataset}_${iteration}.eaf > ${output}/${dataset}_${iteration}_anno.txt 2>  ${output}/${dataset}_${iteration}_anno.err.txt
#create dur file (not adapted)
awk -f dur.awk ${output}/${dataset}_${iteration}_anno.txt > ${output}/${dataset}_${iteration}_durs.txt


#convert the eaf file for adaptation
adapted="_adap"
file=${output}/${dataset}_${iteration}_anno.txt
outFile=${output}/${dataset}_${iteration}_anno${adapted}.txt
cat $file | sed -e 's/openDoorBackward/walking/' > $outFile
cp $outFile "$outFile.tmp"


cat "$outFile.tmp" | sed -e 's/openDoorForward/walking/' > $outFile
cp $outFile "$outFile.tmp"

cat "$outFile.tmp" | sed -e 's/closeDoor/walking/' > $outFile

rm "$outFile.tmp"

#create dur file (adapted)
awk -f dur.awk ${output}/${dataset}_${iteration}_anno${adapted}.txt > ${output}/${dataset}_${iteration}_durs${adapted}.txt

#create dur file for anonymous multiagent model
bash create-ano-ma-durfile.sh ${dataset} ${iteration} ${output} > ${output}/${dataset}_${iteration}_durs_ano_ma.txt
